; Expression classes

(define class/literal       0)
(define class/variable	    1)
(define class/application   2)
(define class/lambda        3)
(define class/letrec	    4)
(define class/if	    5)
(define class/quote	    6)
(define class/begin	    7)
(define class/set!	    8)

; Macro-related classes

(define class/let-syntax    9)
(define class/letrec-syntax 10)

; Definition classes

(define class/define        11)
(define class/define-syntax 12)

; 

(define number-of-classes 13)

(define classes
  (let ((v (make-vector number-of-classes #f)))
    (vector-set! v class/literal       'literal)
    (vector-set! v class/variable      'variable)
    (vector-set! v class/application   'application)
    (vector-set! v class/lambda        'lambda)
    (vector-set! v class/letrec        'letrec)
    (vector-set! v class/if            'if)
    (vector-set! v class/quote         'quote)
    (vector-set! v class/begin         'begin)
    (vector-set! v class/set!          'set!)
    (vector-set! v class/let-syntax    'let-syntax)
    (vector-set! v class/letrec-syntax 'letrec-syntax)
    (vector-set! v class/define        'define)
    (vector-set! v class/define-syntax 'define-syntax)
    v))
